#!/bin/sh


DEV=5
BLDDIR=`pwd`
DIR=${BLDDIR}/fs
CRBIN=frenzy_loader

. ../../config


# removing old frenzyroot
rm frenzyroot.gz

echo -n "[*] Loader stage:"
if [ ! -e crunch/${CRBIN} ]; then
echo -n " build crunch,"
cd crunch

rm crunch.conf
SOURCEDIR="${BLDDIR}/../../${SRCDIR}"
for d in bin sbin usr.bin gnu/usr.bin usr.sbin libexec
do
echo "srcdirs ${SOURCEDIR}/$d" >> crunch.conf
done
echo "" >> crunch.conf
cat crunch.conf.default >> crunch.conf

crunchgen crunch.conf
make -f crunch.mk
cp crunch ${CRBIN}
make clean -f crunch.mk
rm -f crunch.c
rm -f crunch.cache
rm -f crunch.mk
cd ..
fi

exit

BC=2048
#BC=1536
BS=8192
dd if=/dev/zero of=frenzyroot count=${BC} bs=1k
mdconfig -a -t vnode -f frenzyroot -u ${DEV}
bsdlabel -w md${DEV} auto 
newfs -n -i ${BS} -m 0 -o space /dev/md${DEV}
mount /dev/md${DEV} ${DIR} 

echo -n " dirs"
rm -r ${DIR}/*
mtree -eU -f rootfs.mtree -p ${DIR}



echo -n ", links"
cd ${DIR}
cp ${BLDDIR}/crunch/${CRBIN} ${DIR}/sbin
rm ${BLDDIR}/crunch/${CRBIN}
for i in `crunchgen -l ${BLDDIR}/crunch/crunch.conf`
do
ln sbin/${CRBIN} sbin/${i}
done
ln sbin/sh bin/sh  # symlink for sh
echo -n ", files"
(cd ${BLDDIR}/skel && find . -xdev | cpio -pdum --quiet ${DIR})
cd ..

echo -n ", gzip"
umount ${DIR}
mdconfig -d -u ${DEV}
gzip frenzyroot
echo ". All done."


